* Create a CursorAdapter object.

local oCursor as SFCursorAdapter of SFCursorAdapter
oCursor = newobject('SFCursorAdapter', 'SFDataClasses')
with oCursor

* Connect to the SQL Server Northwind database and get customers records.

	.DataSourceType = 'ODBC'
	.DataSource     = sqlstringconnect('driver=SQL Server;server=(local);' + ;
		'database=Northwind;uid=sa;pwd=dhennig;trusted_connection=no')
	.Alias          = 'Customers'
	.SelectCmd      = 'select * from customers'
	if .GetData()
		browse
	else
		messagebox('Could not get the data. The error message was:' + ;
			chr(13) + chr(13) + .cErrorMessage)
	endif .GetData()
endwith
oCursor.Release()

* Now use the connection manager to manage the connection, plus use a
* parameterized query and define some tags for the cursor.

oConnMgr = newobject('SFConnectionMgrODBC', 'SFRemote')
with oConnMgr
	.cDriver   = 'SQL Server'
	.cServer   = '(local)'
	.cDatabase = 'Northwind'
	.cUserName = 'sa'
	.cPassword = 'dhennig'
endwith
if oConnMgr.Connect()
	oCursor = newobject('SFCursorAdapter', 'SFDataClasses')
	with oCursor
		.DataSourceType = 'ODBC'
		.SetConnection(oConnMgr.GetConnection())
		.Alias     = 'Customers'
		.SelectCmd = 'select * from customers where country = ?pcountry'
		.AddParameter('pcountry', 'Brazil')
		.AddTag('CustomerID', 'CustomerID')
		.AddTag('Company',    'upper(CompanyName)')
		.AddTag('Contact',    'upper(ContactName)')
		if .GetData()
			messagebox('Brazilian customers in CustomerID order')
			set order to CustomerID
			go top
			browse
			messagebox('Brazilian customers in Contact order')
			set order to Contact
			go top
			browse
			messagebox('Canadian customers')
			loParameter = .GetParameter('pcountry')
			loParameter.Value = 'Canada'
			.Requery()
			browse
		else
			messagebox('Could not get the data. The error message was:' + ;
				chr(13) + chr(13) + .cErrorMessage)
		endif .GetData()

* Now try to do an invalid SELECT statement.

		.SelectCmd = 'select * from customersx'
		if .GetData()
			browse
		else
			messagebox('Could not get the data. The error message was:' + ;
				chr(13) + chr(13) + .cErrorMessage)
		endif .GetData()
	endwith
else
	messagebox(oConnMgr.cErrorMessage)
endif oConnMgr.Connect()
